package	jp.co.sds_corp.volcano;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.List;

import javax.imageio.ImageIO;
import javax.swing.text.MutableAttributeSet;
import javax.swing.text.html.HTML;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.text.html.parser.ParserDelegator;

import jp.co.sds_corp.util.config.IConfiguration;

public class HtmlSource implements ISource
{
	URL	url;	// 一覧のURL
	List<String>	vecFile = new ArrayList<String>();
	List<URL>	vecUrl = new ArrayList<URL>();
	ParserDelegator parser;
	ParseCallback cb;

	public HtmlSource() {
		parser = new ParserDelegator();
		cb = new ParseCallback();
	}

	public void init( IConfiguration config ) throws Exception {
		IConfiguration attr = config.getAttributes();
		url = new URL( attr.get( "url" ));
	}

	class ParseCallback extends HTMLEditorKit.ParserCallback
	{
		public void handleStartTag( HTML.Tag tag, MutableAttributeSet attr, int pos ) {
			if ( !tag.equals( HTML.Tag.A )) {
				return;
			}
			String file = (String )attr.getAttribute( HTML.Attribute.HREF );
			vecFile.add( file );
		}
	}

	public List<URL> listURL() throws Exception {
		vecFile.clear();
		URLConnection con = url.openConnection();
		InputStreamReader rd = new InputStreamReader( con.getInputStream() );
		parser.parse( rd, cb, true );
		rd.close();

		vecUrl.clear();
		for ( int i = 0; i < vecFile.size(); i++ ) {
			String file = (String )vecFile.get( i );
			URL url;
			if ( file.startsWith( "http://" )) {
				url = new URL( file );
			} else
			if ( file.startsWith( "/" )) {
				url = new URL( "http://" + this.url.getHost() + file );
			} else {
				url = new URL( this.url + file );
			}
			vecUrl.add( url );
		}
		return vecUrl;
	}

	public List<Image> listImage() throws Exception {
		List<Image> ret = new ArrayList<Image>();
		List<URL> list = listURL();
		for ( int i = 0; i < list.size(); i++ ) {
			URL url = (URL )list.get( i );
/*
			URLConnection con = url.openConnection();
			BufferedImage img = ImageIO.read( con.getInputStream() );
*/
			BufferedImage img = ImageIO.read( url );
			if ( img != null ) {
				ret.add( img );
				System.out.println( url + ":" + img );
			}
		}
		return ret;
	}

	/**
	* 一覧のURLを設定します。
	* @param	var		設定するデータ
	*/
	public void setUrl( URL var ) {
		this.url = var;
	}
	/**
	* 一覧のURLを取得します。
	* @return	一覧のURL
	*/
	public URL getUrl() {
		return url;
	}

}

