package	jp.co.sds_corp.volcano;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;
import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Dictionary;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import java.util.Vector;

import javax.imageio.ImageIO;
import javax.media.MediaLocator;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.UIManager;
import javax.swing.WindowConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import jp.co.sds_corp.util.config.DOMConfiguration;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;
import jp.co.sds_corp.util.window.StatusBar;
import jp.co.sds_corp.util.window.WindowUtility;

public class Sakurajima4 extends JFrame
{
	static final CmnLogger logger = CmnLogFactory.getLogger();
	SetupDialog	setup;
	JMenuBar	menuBar;
	ImagePanel	imgPnl = new ImagePanel();
	StatusBar	status;
	JSlider		slider;
	JButton		btnRew2;
	JButton		btnRew1;
	JButton		btnStop;
	JButton		btnFwd1;
	JButton		btnFwd2;
	JButton		btnStart;
	JButton		btnEnd;
	JButton		btnClear;
	List<URL>	listUrl;
	List<Image>	vecImg = new Vector<Image>();
	Map<String,Image>	mapImg = Collections.synchronizedMap( new TreeMap<String,Image>());
	Settings	set = new Settings();
	boolean	bShow = false;
	int		nStart = -1, nEnd = -1;
	Dictionary<Integer,JLabel>	dicMark = new Hashtable<Integer,JLabel>();

	public Sakurajima4() {
		super();
		setTitle( "桜島Viewer" );
		setSize( 650, 630 );
		createControl();
		setMenu();

		addWindowListener( new WindowAdapter() {
			public void windowClosing( WindowEvent e ) {
				closeWindow();
			}
		});
		setDefaultCloseOperation( WindowConstants.DO_NOTHING_ON_CLOSE );
	}

	public void init( IConfiguration config ) throws Exception {
		set.init( config );
		setup = new SetupDialog( this, set );
	}

	private void closeWindow() {
		String msg = "終了しますか?";
		String title = "確認";
		int nRet = JOptionPane.showConfirmDialog( Sakurajima4.this,
					msg, title,
					JOptionPane.YES_NO_OPTION );
		if ( nRet == JOptionPane.YES_OPTION ) {
			System.exit( 0 );
		}
	}

	protected void createControl() {
//		getContentPane().setLayout( new BoxLayout( getContentPane(), BoxLayout.Y_AXIS ));
		getContentPane().add( imgPnl, BorderLayout.CENTER );

		JPanel pnl = new JPanel();
		pnl.setLayout( new BoxLayout( pnl, BoxLayout.Y_AXIS ));

		slider = new JSlider( 0, 0 );
		slider.setMajorTickSpacing( 60 );
		slider.setMinorTickSpacing( 5 );
		slider.setPaintTicks( true );
		slider.addChangeListener( new SliderListener() );
		pnl.add( slider, BorderLayout.CENTER );

		JPanel btnPnl = new JPanel();
		btnPnl.setLayout( new BoxLayout( btnPnl, BoxLayout.X_AXIS ));
		btnRew2 =  new JButton( "|<" );
		btnRew2.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				rewind2( ev );
			}
		});
		btnPnl.add( btnRew2 );
		btnRew1 =  new JButton( "<" );
		btnRew1.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				set.setDirection( -1 );
				startAnimation();
			}
		});
		btnPnl.add( btnRew1 );
		btnStop =  new JButton( "□" );
		btnStop.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				stopAnimation();
			}
		});
		btnPnl.add( btnStop );
		btnFwd1 =  new JButton( ">" );
		btnFwd1.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				set.setDirection( 1 );
				startAnimation();
			}
		});
		btnPnl.add( btnFwd1 );
		btnFwd2 =  new JButton( ">|" );
		btnFwd2.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				forward2( ev );
			}
		});
		btnPnl.add( btnFwd2 );
		btnStart =  new JButton( "Start" );
		btnStart.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				startMark( ev );
			}
		});
		btnPnl.add( btnStart );
		btnEnd =  new JButton( "End" );
		btnEnd.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				endMark( ev );
			}
		});
		btnPnl.add( btnEnd );
		btnClear =  new JButton( "Claer" );
		btnClear.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				clearMark( ev );
			}
		});
		btnPnl.add( btnClear );
		pnl.add( btnPnl );

		status = new StatusBar();
		pnl.add( status );
		getContentPane().add( pnl, BorderLayout.SOUTH );
	}

	protected void rewind2( ActionEvent ev ) {
		slider.setValue( 0 );
		slider.repaint();
	}

	protected void forward2( ActionEvent ev ) {
		if ( vecImg.size() > 0 ) {
			slider.setValue( vecImg.size() - 1 );
			slider.repaint();
		}
	}

	protected void startMark( ActionEvent ev ) {
		int end = nEnd;
		clearMark();
		paintMark( set.getPosition(), end );
	}
	protected void endMark( ActionEvent ev ) {
		int start = nStart;
		clearMark();
		paintMark( start, set.getPosition() );
	}
	protected void clearMark( ActionEvent ev ) {
		clearMark();
		paintMark( -1, -1 );
	}
	protected void clearMark() {
		if ( nStart >= 0 ) {
			dicMark.remove( Integer.valueOf( nStart ));
			nStart = -1;
		}
		if ( nEnd >= 0 ) {
			dicMark.remove( Integer.valueOf( nEnd ));
			nEnd = -1;
		}
	}
	protected void paintMark( int start, int end ) {
		nStart = start;
		nEnd = end;
		if ( nStart >= 0 ) {
			JLabel	lbl1 = new JLabel( "▲" );
			lbl1.setForeground( Color.blue );
			dicMark.put( Integer.valueOf( nStart ), lbl1 );
		}
		if ( nEnd >= 0 ) {
			JLabel	lbl2 = new JLabel( "▲" );
			lbl2.setForeground( Color.red );
			dicMark.put( Integer.valueOf( nEnd ), lbl2 );
		}
		slider.setLabelTable( dicMark );
		slider.setPaintLabels( true );
		slider.repaint();
	}

	protected void setMenu() {
		menuBar = new JMenuBar();
		JMenu menu;
		JMenuItem item;

		menu = new JMenu( "ファイル(F)" );
		menu.setMnemonic( KeyEvent.VK_F );
		menuBar.add( menu );

		item = new JMenuItem( "新規作成(N)", KeyEvent.VK_N );
		item.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				clear();
			}
		});
		menu.add( item );
		item = new JMenuItem( "出力(O)", KeyEvent.VK_O );
		item.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				writeFile();
			}
		});
		menu.add( item );
		item = new JMenuItem( "動画出力(M)", KeyEvent.VK_M );
		item.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				writeMovie();
			}
		});
		menu.add( item );
		menu.addSeparator();
		item = new JMenuItem( "設定(S)", KeyEvent.VK_S );
		item.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				setup();
			}
		});
		menu.add( item );
		item = new JMenuItem( "終了(X)", KeyEvent.VK_X );
		item.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				closeWindow();
			}
		});
		menu.add( item );

		menu = new JMenu( "取り込み(I)" );
		menu.setMnemonic( KeyEvent.VK_I );
		menuBar.add( menu );

		item = new JMenuItem( "開始(S)", KeyEvent.VK_S );
		item.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				readImage();
			}
		});
		menu.add( item );
		item = new JMenuItem( "中断(B)", KeyEvent.VK_B );
		item.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				stopRead();
			}
		});
		item.setEnabled( false );
		menu.add( item );

		menu = new JMenu( "ヘルプ(H)" );
		menu.setMnemonic( KeyEvent.VK_H );
		menuBar.add( menu );

		item = new JMenuItem( "桜島Viewerについて(A)", KeyEvent.VK_A );
		item.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				about();
			}
		});
		menu.add( item );

		setJMenuBar( menuBar );
	}

	protected void clear() {
		vecImg.clear();
		mapImg.clear();
		set.setPosition( 0 );
		bShow = false;
		slider.setMaximum( 0 );
		status.setText( 0, "" );
		imgPnl.setImage( null );
		imgPnl.repaint();
	}
	protected void setup() {
		WindowUtility.center( this, setup );
		setup.setVisible(true);
	}

	Thread writeThr;
	Thread readThr;
	Thread aniThr;
	protected void writeFile() {
		JFileChooser ch = new JFileChooser( "." );
		ch.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
		int ret = ch.showSaveDialog( this );
		if ( ret != JFileChooser.APPROVE_OPTION ) {
			return;
		}
		// String file = ch.getSelectedFile().toURI().toString();
		writeThr = new Thread( new WriteThread( ch.getSelectedFile() ));
		writeThr.start();
	}
	protected void writeMovie() {
		JFileChooser ch = new JFileChooser( "." );
		ch.setFileSelectionMode( JFileChooser.FILES_ONLY );
		int ret = ch.showSaveDialog( this );
		if ( ret != JFileChooser.APPROVE_OPTION ) {
			return;
		}
		String file = ch.getSelectedFile().toURI().toString();
		Thread thr = new Thread( new MovieThread( file ));
		thr.start();
	}
	protected void readImage() {
		if ( readThr != null ) {
			return;
		}
		readThr = new Thread( new ReaderController());
		readThr.start();
	}
	protected void stopRead() {
		if ( readThr != null ) {
			readThr.interrupt();
			try {
				readThr.join();
			} catch ( Exception ex ) {
			}
		}
	}
	private void readEnabled( boolean en ) {
		menuBar.getMenu( 1 ).getItem( 0 ).setEnabled( !en );
		menuBar.getMenu( 1 ).getItem( 1 ).setEnabled( en );
	}

	protected void startAnimation() {
		if ( aniThr != null ) {
			return;
		}
		aniThr = new Thread( new Animation());
		aniThr.start();
	}
	protected void stopAnimation() {
		if ( aniThr != null ) {
			aniThr.interrupt();
		}
	}

	protected void showImage( int idx ) {
		if ( vecImg.size() > idx ) {
			BufferedImage img = (BufferedImage )vecImg.get( idx );
			imgPnl.setImage( img );
			imgPnl.repaint();
			bShow = true;
		}
	}

	protected void about() {
	}

	class ReaderController implements Runnable
	{
		boolean bBreak = false;
		public void run() {
			List<Thread> vecThr = new Vector<Thread>();
			readEnabled( true );
			try {
				ISource src = set.getSource();
				src.setUrl( new URL( set.getUrl() ));
				int num = 0;
				listUrl = src.listURL();
				for ( int i = 0; i < listUrl.size(); i++ ) {
					if ( bBreak || Thread.currentThread().isInterrupted()) {
						break;
					}
					URL file = (URL )listUrl.get( i );
					BufferedImage img;
					img = (BufferedImage )mapImg.get( file.toString() );
					if ( img != null ) {
						num++;
						continue;
					}
					for ( ;; ) {
						for ( int j = 0; j < vecThr.size(); j++ ) {
							Thread thr = (Thread )vecThr.get( j );
							if ( !thr.isAlive()) {
								vecThr.remove( j );
							}
						}
						if ( vecThr.size() < set.getReader() ) {
							break;
						}
						try {
							Thread.sleep( 50 );
						} catch ( Exception ex ) {
							bBreak = true;
							break;
						}
// System.out.print( "." );
					}
System.out.println( "" + file );
					Reader rd = new Reader( file );
					Thread thr = new Thread( rd );
					thr.start();
					vecThr.add( thr );
					slider.setMaximum( num );
					if ( !bShow ) {
						showImage( num );
					}
					num++;
					slider.setValue( set.getPosition() );
				}
				status.setText( 0, "" );
			} catch ( Exception ex ) {
				logger.error( this, "read error", ex );
				JOptionPane.showMessageDialog( null,
					"Error occurred.\n" + ex,
					"Error",
					JOptionPane.ERROR_MESSAGE );
			} finally {
				int nRetry = 0;
				for ( ;; ) {
					for ( int j = 0; j < vecThr.size(); j++ ) {
						Thread thr = (Thread )vecThr.get( j );
						if ( !thr.isAlive()) {
							vecThr.remove( j );
						}
					}
					if ( vecThr.size() == 0 || nRetry > 600 ) {
						break;
					}
					try {
						Thread.sleep( 50 );
					} catch ( Exception ex ) {
					}
					nRetry++;
				}
				vecImg.clear();
				Iterator<String> itr = mapImg.keySet().iterator();
				while( itr.hasNext()) {
					String key = itr.next();
					Image value = mapImg.get( key );
					if ( value != null ) {
						vecImg.add( value );
					}
				}
				if ( vecImg.size() > 0 ) {
					slider.setMaximum( vecImg.size() - 1 );
				}
			}
			readThr = null;
			readEnabled( false );
		}
	}

	class Reader implements Runnable
	{
		URL file;
		Reader( URL file ) {
			this.file = file;
		}
		public void run() {
			try {
				BufferedImage img;
				img = ImageIO.read( file );
				if ( img != null ) {
					mapImg.put( file.toString(), img );
					status.setText( 0, file.toString() );
// System.out.println( "" + file );
				}
			} catch ( Exception ex ) {
				ex.printStackTrace();
			}
		}
	}

	class Animation implements Runnable
	{
		public void run() {
			try {
				for ( ;; ) {
					if ( Thread.currentThread().isInterrupted()) {
						break;
					}
					int pos = set.getPosition();
					showImage( pos );
					slider.setValue( pos );
					slider.repaint();
					if ( set.getDirection() > 0 ) {
						if (( pos + 1 ) >= vecImg.size()) {
							break;
						}
					} else if ( set.getDirection() < 0 ) {
						if ( pos == 0 ) {
							break;
						}
					}
					pos += set.getDirection();
					set.setPosition( pos );
					try {
						Thread.sleep( 1000 / set.getFrameRate() );
					} catch ( InterruptedException iex ) {
						break;
					}
				}
			} catch ( Exception ex ) {
				logger.error( this, "animation error", ex );
				JOptionPane.showMessageDialog( null,
					"Error occurred.\n" + ex,
					"Error",
					JOptionPane.ERROR_MESSAGE );
			}
			aniThr = null;
		}
	}

	class MovieThread implements Runnable
	{
		String file;
		MovieThread( String file ) {
			this.file = file;
/*
			if ( !file.toUpperCase().endsWith( ".MOV" )) {
				this.file = file + ".mov";
			}
*/
		}

		public void run() {
			try {
				MediaLocator oml;
				oml = JpegImagesToMovie.createMediaLocator( file );
				if ( oml == null ) {
					System.err.println("Cannot build media locator from: " + file );
					return;
				}
				BufferedImage img = (BufferedImage )vecImg.get( 0 );
				JpegImagesToMovie imageToMovie = new JpegImagesToMovie();
				if ( set.getContentType() != null ) {
					imageToMovie.setContentType( set.getContentType() );
				}
				List<Image> vec = new ArrayList<Image>();
				for ( int i = 0; i < vecImg.size(); i++ ) {
					if ( nStart >= 0 && i < nStart ) {
						continue;
					}
					if ( nEnd >= 0 && i > nEnd ) {
						break;
					}
					vec.add( vecImg.get( i ));
				}
				imageToMovie.makeMovie( img.getWidth(), img.getHeight(),
								set.getFrameRate(), vec, oml );
			} catch ( Exception ex ) {
				logger.error( this, "make movie error", ex );
				JOptionPane.showMessageDialog( null,
					"Error occurred.\n" + ex,
					"Error",
					JOptionPane.ERROR_MESSAGE );
			}
		}
	}

	class WriteThread implements Runnable
	{
		String path;
		WriteThread( File file ) {
			if ( file.isDirectory()) {
				this.path = file.toString();
			} else {
				this.path = file.getParent();
			}
System.out.println( "write to " + this.path );
		}
		public void run() {
			try {
				Iterator<String> itr = mapImg.keySet().iterator();
				while ( itr.hasNext()) {
					if ( Thread.currentThread().isInterrupted()) {
						break;
					}
					String url = (String )itr.next();
					BufferedImage img = (BufferedImage )mapImg.get( url );
					if ( img == null ) {
						return;
					}
					String name = path + url.substring( url.lastIndexOf( "/" ));
					File file = new File( name );
System.out.println( file );
					try {
						ImageIO.write( img, "jpeg", file );
					} catch ( Exception ex ) {
						logger.error( this, "write file error", ex );
					}
				}
			} catch ( Exception ex ) {
				logger.error( this, "write file error", ex );
				JOptionPane.showMessageDialog( null,
					"Error occurred.\n" + ex,
					"Error",
					JOptionPane.ERROR_MESSAGE );
			}
			aniThr = null;
		}
	}

	class SliderListener implements ChangeListener
	{
		public void stateChanged( ChangeEvent ev ) {
			int pos = slider.getValue();
			if ( pos != set.getPosition() ) {
				set.setPosition( pos );
				showImage( pos );
			}
		}
	}

	class ImagePanel extends JPanel
	{
		private static final long serialVersionUID = 1L;
		BufferedImage img;
		ImagePanel() {
			setSize( 640, 550 );
		}
		void setImage( BufferedImage var ) {
			this.img = var;
			if ( var != null ) {
				setMinimumSize( new Dimension( set.getWidth(), set.getHeight() ));
			}
		}
		public void paint( Graphics gr ) {
			gr.setColor( getBackground());
			gr.fillRect( 0, 0, getWidth(), getHeight());
			if ( img == null ) {
				return;
			}
			gr.drawImage( img, 0, 0,
//				set.getWidth(), set.getHeight(), this );
				img.getWidth(), img.getHeight(), this );
		}
	}

	public static void main( String argv[] ) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception exc) {
			System.err.println( "Error loading L&F: " + exc);
		}
		try {
			Sakurajima4 win = new Sakurajima4();
			String file = System.getProperty( "sakurajima.config" );
			DOMConfiguration config = new DOMConfiguration( file );
			win.init( config.getChild( "Sakurajima" ));
			win.setVisible(true);
			win.toFront();
		} catch ( Throwable ex ) {
			logger.error( Sakurajima4.class, "initialize error", ex );
			JOptionPane.showMessageDialog( null,
				"Error occurred.\n" + ex,
				"Error",
				JOptionPane.ERROR_MESSAGE );
			System.exit( 9 );
		}
	}

}
